import Drawnings.*;
import Entities.EntityAirbus;
import Entities.EntityPlane;
import Generics.AirbusGenericCollection;
import Generics.GenericParametrized;
import MovementStrategy.DrawningObjectAirbus;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;
import javax.swing.*;

public class FormGenerationAirbus extends JFrame {
    Canvas canvas;
    GenericParametrized<EntityAirbus, IDrawningPortholes> generic;
    DrawningAirbus _airbus;
    private int _width = 800;
    private int _height = 500;

    JButton buttonGenerate;

    FormGenerationAirbus() {
        JFrame frame = new JFrame("Генерация аэробусов");
        setSize(800,500);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(null);

        generic = new GenericParametrized<>(50, 50, _width, _height);

        canvas = new FormGenerationAirbus.Canvas();
        canvas.setBounds(0 , 0, _width, _height);

        buttonGenerate = new JButton("Сгенерировать аэробус");
        buttonGenerate.setMargin(new Insets(0, 0, 0, 0));
        buttonGenerate.setBounds(600, 20, 170, 25);

        add(canvas);
        add(buttonGenerate);
        setVisible(true);

        buttonGenerate.addActionListener(GenerateAirbus);
    }

    ActionListener GenerateAirbus = new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            Random rand = new Random();
            // генерация сущности
            EntityAirbus entity;
            if (rand.nextBoolean()) {
                entity = new EntityAirbus(
                        rand.nextInt(200) + 100, rand.nextInt(2000) + 1000,
                        new Color(rand.nextInt(0, 256), rand.nextInt(0, 256), rand.nextInt(0, 256)));
            } else {
                entity = new EntityPlane(rand.nextInt(200) + 100, rand.nextInt(2000) + 1000,
                        new Color(rand.nextInt(0, 256), rand.nextInt(0, 256), rand.nextInt(0, 256)),
                        new Color(rand.nextInt(0, 256), rand.nextInt(0, 256), rand.nextInt(0, 256)),
                        rand.nextBoolean(), rand.nextBoolean());
            }
            generic.addAirbus(entity);
            // генерация иллюминаторов
            IDrawningPortholes potholes;
            int n = rand.nextInt(3);
            if (n == 0)
                potholes = new DrawningPortholesCircle();
            else if (n == 1)
                potholes = new DrawningPortholesHeart();
            else
                potholes = new DrawningPortholesSquare();
            potholes.SetCount(rand.nextInt(1,4)*10);
            generic.addPortholes(potholes);

            // отрисовка
            _airbus = generic.randomDrawingObject();
            _airbus.SetPosition(100, 100);
            canvas.repaint();
        }
    };

    class Canvas extends JComponent {
        public Canvas() {}
        public void paintComponent(Graphics g) {
            super.paintComponents(g);
            Graphics2D g2d = (Graphics2D)g;
            if (_airbus != null)
                _airbus.DrawTransport(g2d);
            super.repaint();
        }
    }
}
