package MovementStrategy;
import Drawnings.*;

public class DrawningObjectAirbus implements IMoveableObject {
    private DrawningAirbus _drawningAirbus = null;

    public DrawningObjectAirbus(DrawningAirbus drawningAirbus)
    {
        _drawningAirbus = drawningAirbus;
    }

    public ObjectParameters GetObjectPosition()
    {
        if (_drawningAirbus == null || _drawningAirbus.entityAirbus == null)
        {
            return null;
        }
        return new ObjectParameters(_drawningAirbus.GetPosX(), _drawningAirbus.GetPosY(), _drawningAirbus.GetWidth(), _drawningAirbus.GetHeight());
    }

    public int GetStep() { return (int)_drawningAirbus.entityAirbus.Step; }
    public boolean CheckCanMove(Direction direction) { return _drawningAirbus.CanMove(direction); }
    public void MoveObject(Direction direction) { _drawningAirbus.MoveTransport(direction); }
}
